summaryrefslogtreecommitdiffstats
path: root/scripts/strip-kmod.sh
diff options
context:
space:
mode:
authorFelix Fietkau <nbd@openwrt.org>2012-02-20 17:38:26 +0000
committerFelix Fietkau <nbd@openwrt.org>2012-02-20 17:38:26 +0000
commitc2590fe9309910c759a9b8a5dbcd7facffe8d982 (patch)
tree3881176f1a6717e8a9fe10f2fea2b9335dd004ca /scripts/strip-kmod.sh
parentc9188104140685f3d13c789f2823dbad5b3ac0f1 (diff)
downloadmaster-31e0f0ae-c2590fe9309910c759a9b8a5dbcd7facffe8d982.tar.gz
master-31e0f0ae-c2590fe9309910c759a9b8a5dbcd7facffe8d982.tar.bz2
master-31e0f0ae-c2590fe9309910c759a9b8a5dbcd7facffe8d982.zip
strip kernel modules more aggressively: make all global symbols local, rename all symbols in the symbol table to make them compress better
SVN-Revision: 30662
Diffstat (limited to 'scripts/strip-kmod.sh')
-rwxr-xr-xscripts/strip-kmod.sh38
1 files changed, 38 insertions, 0 deletions
diff --git a/scripts/strip-kmod.sh b/scripts/strip-kmod.sh
new file mode 100755
index 0000000000..68da9e901b
--- /dev/null
+++ b/scripts/strip-kmod.sh
@@ -0,0 +1,38 @@
+#!/usr/bin/env bash
+[ -n "$CROSS" ] || {
+ echo "The variable CROSS must be set to point to the cross-compiler prefix"
+ exit 1
+}
+
+MODULE="$1"
+
+[ "$#" -ne 1 ] && {
+ echo "Usage: $0 <module>"
+ exit 1
+}
+
+${CROSS}objcopy \
+ --strip-unneeded \
+ -R .comment \
+ -R .pdr \
+ -R .mdebug.abi32 \
+ -R .note.gnu.build-id \
+ -R .gnu.attributes \
+ -R .reginfo \
+ -G __this_module \
+ -x "$MODULE" "$MODULE.tmp"
+
+${CROSS}nm "$MODULE.tmp" | awk '
+BEGIN {
+ n = 0
+}
+
+$3 && $2 ~ /[brtd]/ && $3 !~ /\$LC/ {
+ print "--redefine-sym "$3"=_"n;
+ n = n + 1
+}
+' > "$MODULE.tmp1"
+
+${CROSS}objcopy `cat ${MODULE}.tmp1` ${MODULE}.tmp ${MODULE}.out
+mv "${MODULE}.out" "${MODULE}"
+rm -f "${MODULE}".t*